const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Period_settingsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const period_settings = await db.period_settings.create(
      {
        id: data.id || undefined,

        total_periods_per_day: data.total_periods_per_day || null,
        period_duration: data.period_duration || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await period_settings.setSchool(data.school || null, {
      transaction,
    });

    await period_settings.setSchools(data.schools || null, {
      transaction,
    });

    return period_settings;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const period_settingsData = data.map((item, index) => ({
      id: item.id || undefined,

      total_periods_per_day: item.total_periods_per_day || null,
      period_duration: item.period_duration || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const period_settings = await db.period_settings.bulkCreate(
      period_settingsData,
      { transaction },
    );

    // For each item created, replace relation files

    return period_settings;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const period_settings = await db.period_settings.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.total_periods_per_day !== undefined)
      updatePayload.total_periods_per_day = data.total_periods_per_day;

    if (data.period_duration !== undefined)
      updatePayload.period_duration = data.period_duration;

    updatePayload.updatedById = currentUser.id;

    await period_settings.update(updatePayload, { transaction });

    if (data.school !== undefined) {
      await period_settings.setSchool(
        data.school,

        { transaction },
      );
    }

    if (data.schools !== undefined) {
      await period_settings.setSchools(
        data.schools,

        { transaction },
      );
    }

    return period_settings;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const period_settings = await db.period_settings.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of period_settings) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of period_settings) {
        await record.destroy({ transaction });
      }
    });

    return period_settings;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const period_settings = await db.period_settings.findByPk(id, options);

    await period_settings.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await period_settings.destroy({
      transaction,
    });

    return period_settings;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const period_settings = await db.period_settings.findOne(
      { where },
      { transaction },
    );

    if (!period_settings) {
      return period_settings;
    }

    const output = period_settings.get({ plain: true });

    output.school = await period_settings.getSchool({
      transaction,
    });

    output.schools = await period_settings.getSchools({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userSchools = (user && user.schools?.id) || null;

    if (userSchools) {
      if (options?.currentUser?.schoolsId) {
        where.schoolsId = options.currentUser.schoolsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.schools,
        as: 'school',
      },

      {
        model: db.schools,
        as: 'schools',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.total_periods_per_dayRange) {
        const [start, end] = filter.total_periods_per_dayRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            total_periods_per_day: {
              ...where.total_periods_per_day,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            total_periods_per_day: {
              ...where.total_periods_per_day,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.period_durationRange) {
        const [start, end] = filter.period_durationRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            period_duration: {
              ...where.period_duration,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            period_duration: {
              ...where.period_duration,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.school) {
        const listItems = filter.school.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          schoolId: { [Op.or]: listItems },
        };
      }

      if (filter.schools) {
        const listItems = filter.schools.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          schoolsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.schoolsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.period_settings.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('period_settings', 'school', query),
        ],
      };
    }

    const records = await db.period_settings.findAll({
      attributes: ['id', 'school'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['school', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.school,
    }));
  }
};
